import psutil, subprocess, os

class AspSolver:

    def __init__(self, data, srsprogramfile, solver='dlv'+os.sep+'dlv.mingw.exe'):
        self.cmd = solver
        self.process = None
        self.srsprogramfile = srsprogramfile

    def run(self):
        #f = open("result.txt", "w")
        self.process = subprocess.Popen([self.cmd, "-n=1", "-filter=move", self.srsprogramfile], shell=True)
        # self.process = subprocess.Popen([self.cmd, "-silent", "-n=1", "-filter=move", self.srsprogramfile, 'dlvprogram\\instance.dl'])

    def is_alive(self):
        return psutil.pid_exists(self.process.pid)

    def terminate(self):
        self.process.terminate()
        self.process = None