%
% A basic Metainterpreter using call

traduzione(happy,felice).
traduzione(friend,amico).
traduzione(mother,mamma).

sinonimo(allegro,felice).

felice(anna).
felice(mario).
allegro(gianni).
amico(mario,carlo).
mamma(giorgia,beatrice).
mamma(beatrice,giacomo).
mamma(beatrice,giorgio).
%happy(george).
%mother(anne,carl).
%friend(anne,mary).

equivalente(P,P1):-trad(P,P1).
equivalente(P,P1):-sin(P1,P).

trad(P,Q):-traduzione(P,Q).
trad(P,Q):-traduzione(Q,P).
sin(P,Q):-sinonimo(P,Q).
sin(P,Q):-sinonimo(Q,P).


demo(G):- clause(G,T), call(G).
demo(G):- G =.. [F|L], equivalente(F,F1), 
          G1 =..[F1|L],clause(G1,T),call(G1).
demo(G):- G =.. [F|L], \+ equivalente(F,F1), 
	write('non ho capito rifai la domanda').