minmax(X, X, [X]):-! .
minmax(Min, Max, [X|L]) :- 
		minmax1(Min, Max, L, X, X).

minmax1(PMin, PMax, [], PMin, PMax):-!.
minmax1(Min, Max, [X|L], PMin, PMax):-
		min(X, PMin, V1), 
		max(X, PMax, V2),
		minmax1(Min, Max, L, V1, V2).




min(M1,M2,M2):- M2 =< M1, !.
min(M1,M2,M1).

max(M1,M2,M2):- M2 >= M1, !.
max(M1,M2,M1).

