%
% Given a list, substitutes N subsequent occurrences of element E with single element N*E

compress([H|T], L2):- runcode([H|T], H, 0, L2).

runcode([], C, N, [N*C]).
runcode([H|T], H, N, Z) :-
		N1 is N+1, runcode(T, H, N1, Z).
runcode([H|T], C, N, [N*C|Z]) :-
		H \== C, runcode(T, H, 1, Z).

yes(L1,L2):- compress(L1,L2).
