%
% How to implement symmetry without falling into loops


happy(X):- sunny_day,holds(in_love(X,Y)).
happy(X):- rich(X).

rich(anna).
rich(bob).

sunny_day.

symmetric(in_love).
symmetric(friend).

G:- holds(G),!.

holds(G):- call(G).
holds(G):- G=..[P,A,B], symmetric(P), 
           G1 =..[P,B,A], call(G1).

in_love(john,mary).

friend(anna,bob).



